## mosml-ver-2.10.1.tar.gz

=== examples/Makefile ===
clean:
	cd calc; make clean
	cd cgi; make clean
	cd lexyacc; make clean
	cd manual; make clean
	cd mls; make clean
	cd parsercomb; make clean
	cd pretty; make clean
	cd webserver; make clean
