=== examples/pretty/Makefile ===
all:
	mosml ppexpr.sml
clean:
