=== debian/changelog ===
mosml (2.10.1-0ubuntu0) trusty; urgency=low

  * Initial release

 -- Ken Friis Larsen <ken@friislarsen.net>  Thu, 28 Aug 2014 07:41:21 +0000
