=== debian/control ===
Source: mosml
Section: devel
Priority: optional
Maintainer: Ken Friis Larsen <ken@friislarsen.net>
Build-Depends: debhelper (>= 9), libgmp-dev
Standards-Version: 3.9.5
Homepage: http://mosml.org
Vcs-Git: git://github.com/kfl/mosml


Package: mosml
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgmp10
Description: light-weight implementation of Standard ML (SML).
 Moscow ML:
   * implements the full Standard ML language, as revised 1997,
     including Modules and some extensions
   * yet is backwards compatible with Moscow ML versions prior to 2.00
   * implements large parts of the new SML Basis Library
   * implements separate compilation
   * can produce compact stand-alone executables (a la Caml Light)
   * supports quotations and antiquotations, useful for metaprogramming
